NUIOpen = false
CurrentShop = nil
PlayerLoaded = false

RegisterNetEvent(LoadedEvent)
AddEventHandler(LoadedEvent, function()
	Citizen.Wait(8000)
	GetData()
	PlayerLoaded = true
end)

AddEventHandler('onResourceStart', function(resourceName)
    if (GetCurrentResourceName() == resourceName) then
		GetData()
		PlayerLoaded = true
    end
end)

AddEventHandler('onResourceStop', function(resourceName)
	if (GetCurrentResourceName() == resourceName) then
		if DoesEntityExist(PreviewVehicle) then DeleteEntity(PreviewVehicle) end
	end
end)

Citizen.CreateThread(function()
	Citizen.Wait(1000*30)
	if GetCurrentResourceName() ~= 'brutal_vehicleshop' then
		while true do
			Citizen.Wait(1)
			print("This script was created by Brutal Scripts! Please rename to: 'brutal_vehicleshop'")
		end
	end
end)

function GetData()
	Citizen.Wait(1000)
	SendNUIMessage({
	action = 'SendDefaults', 
	categorys = GetCategorys(), 
	vehicles = GetVehicles(), 
	moneyform = Config['VehicleShops']['MoneyForm'], 
	colours = GetColoursFromConfig(), 
	colourprice = Config['VehicleShops']['ColourExtraMoney'], 
	maxspeed = Config['VehicleShops']['MaxVehiclesSpeed'], 
	tuningconfig = Config['VehicleShops']['Tunings'],
	testdata = {Config['VehicleShops']['TestDrive']['Use'], Config['VehicleShops']['TestDrive']['price']},
	usesell = Config['VehicleShops']['UseVehicleSell']
	})
end

function GetColoursFromConfig()
	ConfigColours = {}
	for k, v in pairs(Config['VehicleShops']['Colours']) do
		table.insert(ConfigColours, {v[1], v[2], v[3]})
	end
	return ConfigColours
end

function GetCategorys()
	Categorys = {}
	for k, v in pairs(Config['VehicleShops']['Shops']) do
		for _k, _v in pairs(v.Caregorys) do
			table.insert(Categorys, {k, v.SeveralCategorys, _v.title})
		end
	end
	return Categorys
end

function GetVehicles()
	Vehicles = {}
	for k, v in pairs(Config['VehicleShops']['Shops']) do
		for _k, _v in pairs(v.Caregorys) do
			for __k, __v in pairs(_v.vehicles) do
				table.insert(Vehicles, {__v.model, __v.label, __v.price, _v.title, k, __v.type})
			end
		end
	end
	return Vehicles
end

Citizen.CreateThread(function()
	Citizen.Wait(1000)
	for k, v in pairs(Config['VehicleShops']['Shops']) do
		if v.Use and v.Blip.Use then
			local ShopBlip = AddBlipForCoord(v.Coords.x, v.Coords.y, v.Coords.z)
			SetBlipSprite(ShopBlip, v.Blip.sprite)
			SetBlipColour(ShopBlip, v.Blip.colour)
			SetBlipScale(ShopBlip, v.Blip.size)
			BeginTextCommandSetBlipName('STRING')
			AddTextComponentSubstringPlayerName(v.Blip.label)
			EndTextCommandSetBlipName(ShopBlip)
			SetBlipAsShortRange(ShopBlip, true)
		end
	end
end)

UIHide = false
UICoords = {}

Citizen.CreateThread(function()
	Citizen.Wait(1000)
	while true do
		local coords = GetEntityCoords(PlayerPedId())
		sleep = 1000

		for k, v in pairs(Config['VehicleShops']['Shops']) do
			if NUIOpen == false and InSellVehicle == false then
				local distance = (coords - vector3(v.Coords.x, v.Coords.y, v.Coords.z))
				if (#distance < v.Marker.Distance) then
					sleep = 1
					DrawMarker(v.Marker.Sprite, v.Coords.x, v.Coords.y, v.Coords.z, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 1.0, 1.0, 1.0, v.Marker.r, v.Marker.g, v.Marker.b, v.Marker.Brightness, v.Marker.UpAndDown, false, true, v.Marker.Rotation, nil, true)
				end

				if (#distance < v.TextDistance) then
					sleep = 1

					if UIHide == false and StartBuy == false then
						UICoords = {v.Coords.x, v.Coords.y, v.Coords.z, v.TextDistance}
						UIHide = true
						SendNUIMessage({action = 'SellNotify', text = Config['VehicleShops']['OpenShop']})
					end

					if IsControlJustReleased(0, Config['VehicleShops']['MenuOpenKey']) then
						if PlayerLoaded and not (GetEntityHealth(PlayerPedId()) <= PlayerDiedHealth) then
							if PlayerInVehicle() == false then
								CurrentShop = k
								SendNUIMessage({action = "open", currentshop = CurrentShop})
								SetNuiFocus(true,true)
								GPS_Disable()
								NUIOpen = true
								SendNUIMessage({action = 'SellNotifyHide'})
								UIHide = false
								UICoords = {}
								TriggerEvent('brutal_vehicleshop:client:onMenuOpen')
								GetPlayerLive()  -- Check player live
								PreviewCamera(false)
							else
								SendNotify(7)
							end
						end
					end
				end
			end
        end

		if UIHide and UICoords ~= nil and (#(coords - vector3(UICoords[1], UICoords[2], UICoords[3])) > UICoords[4]) then
			SendNUIMessage({action = 'SellNotifyHide'})
			UIHide = false
			UICoords = {}
		end

		Citizen.Wait(sleep)
	end
end)

RegisterNUICallback("UseButton", function(data)
	if data.action == "close" then
		SetNuiFocus(false,false)
		GPS_Enable()
		DefaultCam()
		Citizen.Wait(600)
		NUIOpen = false
		TriggerEvent('brutal_vehicleshop:client:onMenuClose')
	elseif data.action == "back" then
		PreviewCamera(false)
	elseif data.action == "sell" then
		SendNUIMessage({action = 'NUIClose'})
		SetNuiFocus(false,false)
		GPS_Enable()
		PreviewCamera(false)
		Citizen.Wait(600)
		NUIOpen = false
		TriggerEvent('brutal_vehicleshop:client:onMenuClose')
		TriggerEvent('brutal_vehicleshop:client:SellVehicle')
	elseif data.action == "successsell" then
		SetNuiFocus(false,false)
		TSCB('brutal_vehicleshop:server:CheckPlayerOwned', function(Owner)
            if Owner then
				SendNotify(6)
				TaskLeaveVehicle(PlayerPedId(), SellVehicle.vehicle)
				NetworkFadeOutEntity(SellVehicle.vehicle, true, false) 
				Citizen.Wait(3000)
				NetworkFadeInEntity(SellVehicle.vehicle, 0)
				DeleteEntity(SellVehicle.vehicle)
				TriggerServerEvent('brutal_vehicleshop:server:AddMoney', SellVehicle.price, SellVehicle.plate)
			else
                SendNotify(5)
            end
		end, SellVehicle.modelhash, SellVehicle.model, SellVehicle.plate, SellVehicle.price)
	elseif data.action == "sellcancel" then
		SetNuiFocus(false,false)
		SellVehicle.modelhash = nil
		SellVehicle.model = nil
		SellVehicle.price = nil
		SellVehicle.plate = nil
		SellVehicle.vehicle = nil
	end
end)